<template>
  <div class="zxDiffOrder pagePadding">
    <div
      v-if=" powers.some((i) => i == '001')"
    >
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <el-col :span="24">
                <!--                
                <el-col :span="4" style="width: 400px;">
                  <search-customer
                    :value="customerCode"
                    :size="searchSize"
                    :placeholder="'购买方公司名称'"
                    @searchChange="customerChange"
                  />
                </el-col>

                <el-col :span="4" style="width: 410px; padding: 0 0 0 10px">
                  <search-customer
                    :value="customerCode"
                    :size="searchSize"
                    :placeholder="'购买方公司名称'"
                    @searchChange="customerChange"
                  />
                </el-col> -->
                <!-- <el-col :span="4" style="width: 140px">
                  <el-select
                    :size="searchSize"
                    v-model="parmValue.status"
                    filterable
                    clearable
                    placeholder="竞价类型"
                    style="width: 100%"
                    @change="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      searchList();
                    "
                  >
                    <el-option
                      v-for="item in statusList"
                      :key="'status' + item"
                      :label="iteme"
                      :value="item"
                    />
                  </el-select>
                </el-col> -->
                <el-col :span="6" style="width: 293px;">
                  <period-date-picker
                    :start="parmValue.start"
                    :end="parmValue.end"
                    :type="1"
                    :width="'135px'"
                    :size="searchSize"
                    @timeReturned="timeReturned($event)"
                  />
                </el-col>
                <el-col :span="4" style="width: 300px; padding: 0 0 0 10px">
                  <el-input
                    placeholder="订单编号"
                    v-model="parmValue.orderCode"
                    :size="searchSize"
                    :maxlength="40"
                    @blur="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      searchList();
                    "
                  >
                    <el-button
                      slot="append"
                      icon="el-icon-search"
                      @click="
                        pageInfo.curr = 1;
                        parmValue.page = 1;
                        searchList();
                      "
                    ></el-button>
                  </el-input>
                </el-col>
                <el-col :span="3" style="width: 66px; float: right">
                  <el-button
                    :size="searchSize"
                    type="primary"
                    style="float: right; margin-left: 5px"
                    @click="searchList"
                  >
                    刷新
                  </el-button>
                </el-col>
                <el-col :span="4" style="width: 66px; float: right">
                  <el-button
                    type="warning"
                    class="fr"
                    :size="searchSize"
                    @click="restSearch"
                  >
                    重置
                  </el-button>
                </el-col>
              </el-col>
            </el-row>
          </div>
        </template>
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (statusOptions.find((item) => item.id == scope.row.status) || {})
                .label || '--'
            "
          ></el-tag>
        </template>
        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((i) => i == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i
              class="el-icon-view tb-icon"
             
              @click="getRouter('zxDiffOrderDetail', scope.row.id )"
            ></i>
          </el-tooltip>
        </template>
      </ex-table>
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
   <script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import asyncRequest from "@/apis/service/sellOut/zxDiffOrder";
import { mapGetters } from "vuex";
import { columns } from "./columns";
export default {
  name: "zxDiffOrder",
  mixins: [mixinPage, resToken],
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "zxDiffOrder"
        ) || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      select: "1",
      input: "",
      addShowModel: false,
      addModelId: "",
      addIsDetail: false,

      customerCode: [],
      sitem: null,
      // 状态
      statusOptions: [
        { id: "1", label: "待业务部门审核" },
        { id: "2", label: "工差单审核完成" },
      ],
      statusList: [
        "样品竞价单",
        "线上竞价",
        "线上贵金属",
        "线下竞价",
        "线下贵金属",
        "赠品竞价单",
        "项目竞聘",
      ],
      loading: true,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        zxNo: "", // 竞价单编码
        khNo: "", // 客户编码
        cpName: "", //商品名称
        status: "", //竞价类型
        salesman: "", //申请人
        start: "",
        end: "",
        page: 1, // 页码
        size: 15, // 每页显示条数
      },
      tableData: [],
      passwordModel: false,
      passwordModelId: 0,
      isPasswordDetail: false,
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: columns,
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      console.log(this.parmValue)
      const {page,size}=this.parmValue;
      // this.parmValue.start = start || last_start;
      // this.parmValue.end = end || last_end;
      // if(this.parmValue.companyNo.length>0){
      //     this.customerCode = [this.parmValue.companyNo] ;
      // }
      
       this.pageInfo= {
        size: size,
        curr: page,
        total: 0,
      }
      //多选条件
    this.select = this.parmValue.select;
    // this.sselect = this.parmValue.sselect;
    this.s_input = this.parmValue.s_input

    }else{
       this.select = "1";
      //  this.sselect = "创建时间"
    }
    this.searchList();
  },

  methods: {
    getRouter(toRouter, queryId){
      if (toRouter && queryId) {
        let model = {
          id: queryId,
          // type: 'view',
        };

        //有多选框的条件
        this.parmValue.select = this.select ;
        // this.parmValue.sselect = this.sselect ;
        this.parmValue.s_input= this.s_input;
        //
         let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);
        
        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    async timeReturned(e) {
      if (e.startTime !== "") {
        this.parmValue.start = e.startTime;
      } else {
        this.parmValue.start = "";
      }

      if (e.endTime !== "") {
        this.parmValue.end = e.endTime;
      } else {
        this.parmValue.end = "";
      }
      if (this.parmValue.start !== "" && this.parmValue.end !== "") {
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
    restSearch() {
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.select = "1";
      this.input = "";
      this.customerCode = [];
      this.parmValue = {
        zxNo: "", // 竞价单编码
        khNo: "", // 客户编码
        cpName: "", //商品名称
        status: "", //竞价类型
        salesman: "", //申请人
        start: "",
        end: "",
        page: 1, // 页码
        size: 15, // 每页显示条数
      };
      this.searchList();
    },
    async customerChange(e) {
      if (e && e.id) {
        this.customerCode = [e.code];
        this.parmValue.khNo = e.code;
      } else {
        this.customerCode = [];
        this.parmValue.khNo = "";
      }
      this.parmValue.page = 1;
      await this.searchList();
    },
    openModal(id, isDetail) {
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
    },
    addModal(id, isDetail) {
      this.addShowModel = true;
      this.addModelId = id;
      this.addIsDetail = isDetail;
    },
    async deleteById(id, status) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
            // status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.delete(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async searchList() {
         if (
        (this.parmValue.start !== "" && this.parmValue.end === "") ||
        (this.parmValue.start == "" && this.parmValue.end != "")
      ) {
        this.$message.warning("开始时间和结束时间不能为空");
        return;
      }
      this.loading = true;
      this.parmValue.zxNo = this.select === "1" ? this.input : ""; //竞价类型
      this.parmValue.salesman = this.select === "2" ? this.input : ""; //申请人
      this.parmValue.cpName = this.select === "3" ? this.input : ""; //商品名称
      const res = await asyncRequest.list(this.parmValue);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.tableData.map((v) => {
          v.sale_price = this.setNum(v.sale_price);
          v.sale_fee = this.setNum(v.sale_fee);
          v.class_cat = "";
          if (v.can && v.can.length > 0) {
            v.can.forEach((x, i) => {
              v.class_cat += i === 0 ? x.name : "/" + x.name;
            });
          }
          return v;
        });
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },
  },
};
</script>
   <style lang="scss" scoped>
.zxDiffOrder {
}
</style>
   